Const xr = 300, yr = 600, fps = 60, schussfeld = 360, SchussRadius = 2
Graphics xr, yr, 0, 2
AppTitle("Shooty")
SeedRnd MilliSecs()
Global fps_timer = CreateTimer(fps)



Type Kugel
	Field x#
	Field y#
	Field radius
	Field vx#
	Field vy#
	Field r, g, b
	Field deletion
End Type
Global K.Kugel

Type Schuss
	Field x#
	Field y#
	Field vx#
	Field vy#
	Field deletion
End Type
Global S.Schuss


	SetBuffer BackBuffer()
	ClsColor 163, 163, 255
	FlushMouse()

	Cls
	Color 61, 61, 155
	Rect 0, schussfeld, xr, yr - schussfeld, 0
	Color 0, 0, 0
	Text 10, 10,  "Hold down your left mousebutton and"
	Text 10, 36,  "move your mouse up to shoot at the"
	Text 10, 62,  "colored bubbles which are moving"
	Text 10, 88,  "down. If a bubble reaches the bottom"
	Text 10, 114, "you lose."
	Text 10, 140, "You can only shoot within the bottom"
	Text 10, 166, "box. - Click to begin."

	Flip()
	WaitMouse()
	FlushMouse()




.start
	startTimer = MilliSecs()
	ende = False
	Repeat
		mouse_x = MouseX()
		mouse_y = MouseY()

		wahrscheinlichkeit = 200 - (MilliSecs() - startTimer) / 10000
		If Rand(200) >= wahrscheinlichkeit Then
			K = New Kugel
			K\radius = Rand(10, 50)
			K\x = Rand(K\radius, xr - K\radius)
			K\y = -K\radius
			K\vx = 50. / Rand(50, 100)
			If Rand(0, 1) Then K\vx = -K\vx
			K\vy = 50 / Rand(30, 100)
			K\r = Rand(255): K\g = Rand(255): K\b = Rand(255)
			K\deletion = False
		End If
			





		Cls
		Color 61, 61, 155
		Rect 0, schussfeld, xr, yr - schussfeld, 0

		Color 255, 255, 255
		If drag = 1 Then
			Oval mouse_x - SchussRadius, mouse_y - SchussRadius, 2 * SchussRadius, 2 * SchussRadius, 0
		End If

		For S = Each Schuss
			S\x = S\x + S\vx
			S\y = S\y + S\vy
			Color 255, 255, 255
			Oval S\x - SchussRadius, S\y - SchussRadius, 2 * SchussRadius, 2 * SchussRadius, 0
			If S\x < 0 Or S\x > xr Then
				S\vx = -S\vx
			End If

			If S\y < 0 Or S\y > yr Or S\deletion Then Delete S

		Next

		mouseInKugel = False
		For K = Each Kugel
			K\x = K\x + K\vx
			K\y = K\y + K\vy
			Color 155, 32, 32
			Oval K\x - K\radius, K\y - K\radius, 2 * K\radius, 2 * K\radius
			Color K\r, K\g, K\b
			Oval K\x - K\radius + 1, K\y - K\radius + 1, 2 * K\radius - 2, 2 * K\radius - 2
			If K\x < K\radius Or K\x > xr - K\radius Then
				K\vx = -K\vx
			End If
			If K\y > yr Then ende = True
			For S = Each Schuss
				If distance(K\x, K\y, S\x, S\y) < K\radius + SchussRadius Then
					K\radius = K\radius - 5
					If K\radius < 10 Then K\deletion = True
					S\deletion = True
				End If
			Next
			If distance(K\x, K\y, mouse_x, mouse_y) <= K\radius Then mouseInKugel = True
			If K\deletion Then Delete K
			
		Next


		If MouseDown(1) And mouse_y >= schussfeld And drag = 0 And mouseInKugel = False Then
			neuSchussStartX = mouse_x
			neuSchussStartY = mouse_y
			drag = 1
			schussAnlauf = 0
		End If

		If MouseDown(1) And drag = 1 Then
			schussAnlauf = schussAnlauf + 1
			If mouse_y < schussfeld Then drag = 0
		End If

		If (Not MouseDown(1)) And drag = 1 Then
			S = New Schuss
			S\x = mouse_x
			S\y = mouse_y
			S\vx = Sqr(Abs(mouse_x - neuSchussStartX) / Float(schussAnlauf)) * Sgn(mouse_x - neuSchussStartX)
			S\vy = Sqr(Abs(mouse_y - neuSchussStartY) / Float(schussAnlauf)) * Sgn(mouse_y - neuSchussStartY)
			DebugLog S\vy
			If S\vy = 0 Then Delete S
			drag = 0
		End If

		Color 61, 61, 155
		zeit$ = "time wasted: " + (MilliSecs() - startTimer) / 1000
		Text xr - StringWidth(zeit$) - 5, yr - 16, zeit$
		Flip(0)
		WaitTimer fps_timer
	Until KeyDown(1) Or ende

	If ende Then
		Color 255, 255, 0
		go$ = "G A M E   O V E R"
		Text (xr - StringWidth(go)) / 2, 10, go
		Color 255, 255, 255
		go$ = "( Rightklick to play once more )"
		Text (xr - StringWidth(go)) / 2, 40, go
		Flip()
		FlushMouse()
		Repeat
		Until KeyDown(1) Or MouseHit(2)
		If KeyDown(1) Then End
		For K = Each Kugel: Delete K: Next
		For S = Each Schuss: Delete S: Next
		drag = 0
		Goto start
	End If

Function distance(x1, y1, x2, y2)

	Return Sqr( (x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2) )

End Function

;~IDEal Editor Parameters:
;~C#Blitz3D